KDE 4.9 PyKDE API Reference

- KDE's Python API

# Factory Class Reference

`from PyKDE4.kparts import *`

Inherits: KPluginFactory → QObject
Namespace: KParts

## Detailed Description

A generic factory object to create a Part.

Factory is an abstract class. Reimplement the createPartObject() method to give it functionality.

See also:
  KLibFactory.

## Methods

| __init__ (self, QObject parent=0)
KParts.Part | createPart (self, QWidget parentWidget=0, QObject parent=0, QString classname="KParts.Part", QStringList args=QStringList())
KParts.Part | createPartObject (self, QWidget parentWidget=0, QObject parent=0, QString classname="KParts.Part", QStringList args=QStringList())
KComponentData | partComponentData (self)

## Static Methods

KComponentData | partComponentDataFromLibrary (QString libraryName)

## Method Documentation

__init__ | ( | self, |
|  | QObject | parent=0
| ) |  |  |

KParts.Part createPart | ( | self, |
|  | QWidget | parentWidget=0,
|  | QObject | parent=0,
|  | QString | classname="KParts.Part",
|  | QStringList | args=QStringList()
| ) |  |  |

Creates a part.

The QStringList can be used to pass additional arguments to the part. If the part needs additional arguments, it should take them as name="value" pairs. This is the way additional arguments will get passed to the part from eg. khtml. You can for example emebed the part into HTML by using the following code:

        <object type="my_mimetype" data="url_to_my_data">
            <param name="name1" value="value1">
            <param name="name2" value="value2">
        </object>

This could result in a call to

         createPart( parentWidget, parentObject, "KParts.Part",
                     QStringList("name1="value1"", "name2="value2") );

Returns:
  the newly created part.

createPart() automatically emits a signal KLibFactory.objectCreated to tell the library about its newly created object. This is very important for reference counting, and allows unloading the library automatically once all its objects have been destroyed.

KParts.Part createPartObject | ( | self, |
|  | QWidget | parentWidget=0,
|  | QObject | parent=0,
|  | QString | classname="KParts.Part",
|  | QStringList | args=QStringList()
| ) |  |  |

Abstract method:
  This method is abstract and can be overridden but not called directly.

Reimplement this method in your implementation to create the Part.

The QStringList can be used to pass additional arguments to the part. If the part needs additional arguments, it should take them as name="value" pairs. This is the way additional arguments will get passed to the part from eg. khtml. You can for example emebed the part into HTML by using the following code:

        <object type="my_mimetype" data="url_to_my_data">
            <param name="name1" value="value1">
            <param name="name2" value="value2">
        </object>

This could result in a call to

         createPart( parentWidget, parentObject, "KParts.Part",
                     QStringList("name1="value1"", "name2="value2") );

Returns:
  the newly created part.

KComponentData partComponentData | ( |  | self ) |

If you have a part contained in a shared library you might want to query for meta-information like the about-data, or the KComponentData in general. If the part is exported using KParts.GenericFactory then this method will return the instance that belongs to the part without the need to instantiate the part component.

## Static Method Documentation

KComponentData partComponentDataFromLibrary | ( | QString | libraryName
| ) |  |  |

A convenience method for partComponentData that takes care of retrieving the factory for a given library name and calling partComponentData on it.

Parameters:

  | libraryName | name of the library to query the instance from